package com.jkcredit.traffic.record.test;

import java.io.*;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.List;

public class Test {

    public static void splitFile(String filePath, int fileCount, String tempFilePath) throws IOException {
        FileInputStream fis = new FileInputStream(filePath);

        FileChannel inputChannel = fis.getChannel();
        final long fileSize = inputChannel.size();
        long average = fileSize / fileCount;//平均值
        long bufferSize = 2048; //缓存块大小，自行调整
        ByteBuffer byteBuffer = ByteBuffer.allocate(Integer.parseInt(bufferSize + "")); // 申请一个缓存区
        long startPosition = 0; //子文件开始位置
        long endPosition = average < bufferSize ? 0 : average - bufferSize;//子文件结束位置
        for (int i = 0; i < fileCount; i++) {
            if (i + 1 != fileCount) {
                int read = inputChannel.read(byteBuffer, endPosition);// 读取数据
                readW:
                while (read != -1) {
                    byteBuffer.flip();//切换读模式
                    byte[] array = byteBuffer.array();
                    for (int j = 0; j < array.length; j++) {
                        byte b = array[j];
                        if (b == 10 || b == 13) { //判断\n\r
                            endPosition += j;
                            break readW;
                        }
                    }
                    endPosition += bufferSize;
                    byteBuffer.clear(); //重置缓存块指针
                    read = inputChannel.read(byteBuffer, endPosition);
                }
            }else{
                endPosition = fileSize; //最后一个文件直接指向文件末尾
            }

            File tempFile = new File(tempFilePath);
            if (!tempFile.exists()) {
                tempFile.mkdir();
            }
            FileOutputStream fos = new FileOutputStream(tempFilePath + "\\temp_" + (i + 1) + ".csv");
            FileChannel outputChannel = fos.getChannel();
            inputChannel.transferTo(startPosition, endPosition - startPosition, outputChannel);//通道传输文件数据
            outputChannel.close();
            fos.close();
            startPosition = endPosition + 1;
            endPosition += average;
        }
        inputChannel.close();
        fis.close();
    }

    public static void createBigFile() throws IOException {
        File file = new File("C:\\Users\\lin\\Desktop\\test\\originalFile.csv");
        FileWriter fileWriter = new FileWriter(file);
        BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);
        String str = "202104,京A123C48_1,8790.0,87392.0,2638403.0,2638403.0,2638403.0,2638403.0,2638403.0,2638403.0";
        for (int i = 0; i < 10000000; i++) {
            bufferedWriter.write(str);
            bufferedWriter.newLine();
        }
        bufferedWriter.flush();
        bufferedWriter.close();
    }

    public static void readSplitFiles(String filePath) throws IOException{
        File baseFile = new File(filePath);
        File[] files = baseFile.listFiles();
        List<String> result = new ArrayList<>(1200000);


        for (File file : files) {
            FileInputStream fis = new FileInputStream(file);
            FileChannel inputChannel = fis.getChannel();
            long bufferSize = 2048; //缓存块大小，自行调整
            ByteBuffer byteBuffer = ByteBuffer.allocate(Integer.parseInt(bufferSize + "")); // 申请一个缓存区
            int read = inputChannel.read(byteBuffer);// 读取数据
            readW:
            while (read != -1) {
                System.out.println(byteBuffer.toString());
//                result.add(byteBuffer.toString());
//            byteBuffer.flip();//切换读模式
//            byte[] array = byteBuffer.array();
//            for (int j = 0; j < array.length; j++) {
//                byte b = array[j];
//                if (b == 10 || b == 13) { //判断\n\r
//                    break readW;
//                }
//            }
//            byteBuffer.clear(); //重置缓存块指针
//            read = inputChannel.read(byteBuffer);
            }
            System.out.println(result.size());
        }

    }

    public static void main(String[] args) {
        try {
            splitFile("/Users/jkxy/Desktop/test/test/part-00001.csv", 10, "/Users/jkxy/Desktop/test/test/temp");
        } catch (Exception e) {
            e.printStackTrace();
        }

//        try {
//            readSplitFiles("C:\\Users\\lin\\Desktop\\test\\temp");
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
    }
}
